Yate: ClientSound Class Reference

Yate

Public Member Functions | Static Public Member Functions | Static Public Attributes | Protected Member Functions | Protected Attributes | List of all members
ClientSound Class Reference

A sound file. More...

`#include <yatecbase.h>`

Inheritance diagram for ClientSound:

## Public Member Functions
| ClientSound (const char *name, const char *file, const char *device=0)
virtual | ~ClientSound ()
virtual void | destruct ()
bool | native () const
bool | started () const
const String & | device () const
void | device (const char *dev)
const String & | file () const
void | file (const char *filename, bool stereo)
void | setRepeat (unsigned int count)
bool | stereo () const
bool | start (bool force=true)
void | stop ()
void | setChannel (const String &chan, bool ok)
bool | attachSource (ClientChannel *chan)
Public Member Functions inherited from String
| String ()
| String (const char *value, int len=-1)
| String (char value, unsigned int repeat=1)
| String (int32_t value)
| String (uint32_t value)
| String (int64_t value)
| String (uint64_t value)
| String (bool value)
| String (double value)
| String (const String &value)
| String (const String *value)
virtual | ~String ()
virtual void * | getObject (const String &name) const
const char * | c_str () const
const char * | safe () const
const char * | safe (const char *defStr) const
unsigned int | length () const
bool | null () const
int | lenUtf8 (uint32_t maxChar=0x10ffff, bool overlong=false) const
int | fixUtf8 (const char *replace=0, uint32_t maxChar=0x10ffff, bool overlong=false)
unsigned int | encodeFlags (const TokenDict *tokens) const
uint64_t | encodeFlags (const TokenDict64 *tokens) const
String & | decodeFlags (unsigned int flags, const TokenDict *tokens, bool unknownflag=true)
String & | decodeFlags (uint64_t flags, const TokenDict64 *tokens, bool unknownflag=true)
bool | checkBOM () const
bool | stripBOM ()
unsigned int | hash () const
void | clear ()
char | at (int index) const
String | substr (int offs, int len=-1) const
String & | trimBlanks ()
String & | trimSpaces ()
virtual const String & | toString () const
int | toInteger (int defvalue=0, int base=0, int minvalue=INT_MIN, int maxvalue=INT_MAX, bool clamp=true) const
int | toInteger (const TokenDict *tokens, int defvalue=0, int base=0) const
int | toInteger (const TokenDictStr *tokens, int defvalue=0, int base=0) const
long int | toLong (long int defvalue=0, int base=0, long int minvalue=LONG_MIN, long int maxvalue=LONG_MAX, bool clamp=true) const
int64_t | toInt64 (int64_t defvalue=0, int base=0, int64_t minvalue=LLONG_MIN, int64_t maxvalue=LLONG_MAX, bool clamp=true) const
int64_t | toInt64Dict (const TokenDict64 *tokens, int64_t defvalue=0, int base=0) const
int64_t | toInt64Dict (const TokenDictStr64 *tokens, int64_t defvalue=0, int base=0) const
uint64_t | toUInt64 (uint64_t defvalue=0, int base=0, uint64_t minvalue=0, uint64_t maxvalue=ULLONG_MAX, bool clamp=true) const
double | toDouble (double defvalue=0.0) const
bool | toBoolean (bool defvalue=false) const
bool | isBoolean () const
String & | toUpper ()
String & | toLower ()
char | operator[] (signed int index) const
char | operator[] (unsigned int index) const
| operator const char * () const
String & | assign (const char *value, int len=-1)
String & | assign (char value, unsigned int repeat=1)
String & | hexify (const void *data, unsigned int len, char sep=0, bool upCase=false)
String & | operator= (const String &value)
String & | operator= (const String *value)
String & | operator= (const char *value)
String & | operator= (char value)
String & | operator= (int32_t value)
String & | operator= (uint32_t value)
String & | operator= (int64_t value)
String & | operator= (uint64_t value)
String & | operator= (bool value)
String & | operator= (double value)
String & | operator+= (const char *value)
String & | operator+= (char value)
String & | operator+= (int32_t value)
String & | operator+= (uint32_t value)
String & | operator+= (int64_t value)
String & | operator+= (uint64_t value)
String & | operator+= (bool value)
String & | operator+= (double value)
bool | operator== (const char *value) const
bool | operator!= (const char *value) const
bool | operator== (const String &value) const
bool | operator!= (const String &value) const
bool | operator&= (const char *value) const
bool | operator|= (const char *value) const
String & | operator<< (const char *value)
String & | operator<< (char value)
String & | operator<< (int32_t value)
String & | operator<< (uint32_t value)
String & | operator<< (int64_t value)
String & | operator<< (uint64_t value)
String & | operator<< (bool value)
String & | operator<< (double value)
String & | operator>> (const char *skip)
String & | operator>> (char &store)
String & | operator>> (UChar &store)
String & | operator>> (int &store)
String & | operator>> (unsigned int &store)
String & | operator>> (bool &store)
String & | append (const char *value, int len)
String & | append (const char *value, const char *separator=0, bool force=false)
String & | append (const ObjList *list, const char *separator=0, bool force=false)
String & | append (const ObjList &list, const char *separator=0, bool force=false)
String & | append (char value, unsigned int len=1)
String & | append (double value, unsigned int decimals=3)
String & | insert (unsigned int pos, const char *value, int len=-1)
String & | insert (unsigned int pos, char value, unsigned int len=1)
String & | printf (const char *format,...)
String & | printf (unsigned int length, const char *format,...)
String & | printfAppend (const char *format,...)
String & | printfAppend (unsigned int length, const char *format,...)
String & | appendFixed (unsigned int fixedLength, const char *str, unsigned int len=-1, char fill=' ', int align=Left)
String & | appendFixed (unsigned int fixedLength, const String &str, char fill=' ', int align=Left)
int | find (char what, unsigned int offs=0) const
int | find (const char *what, unsigned int offs=0) const
int | rfind (char what) const
int | rfind (const char *what) const
bool | startsWith (const char *what, bool wordBreak=false, bool caseInsensitive=false) const
bool | endsWith (const char *what, bool wordBreak=false, bool caseInsensitive=false) const
bool | startSkip (const char *what, bool wordBreak=true, bool caseInsensitive=false)
String & | replaceChars (const char *what, const char *repl, bool inPlace=false, int wLen=-1, int rLen=-1, bool *chg=0)
String & | removeChars (const char *what, int wLen=-1, bool *chg=0)
String & | extractTo (const char *sep, String &store)
String & | extractTo (const char *sep, bool &store)
String & | extractTo (const char *sep, int &store, int base=0)
String & | extractTo (const char *sep, int &store, const TokenDict *tokens, int base=0)
String & | extractTo (const char *sep, double &store)
virtual bool | matches (const String &value) const
bool | matches (const Regexp &rexp)
int | matchOffset (int index=0) const
int | matchLength (int index=0) const
String | matchString (int index=0) const
String | replaceMatches (const String &templ) const
int | matchCount () const
ObjList * | split (ObjList &list, char separator, bool emptyOK=true) const
ObjList * | split (ObjList &list, const Regexp &reg, bool emptyOK=true) const
ObjList * | split (char separator, bool emptyOK=true) const
ObjList * | split (const Regexp &reg, bool emptyOK=true) const
String | msgEscape (char extraEsc=0) const
String | msgUnescape (int *errptr=0, char extraEsc=0) const
String | sqlEscape (char extraEsc=0) const
String & | uriEscapeTo (String &buf, char extraEsc=0, const char *noEsc=0) const
String | uriEscape (char extraEsc=0, const char *noEsc=0) const
String & | uriUnescapeTo (String &buf, bool setPartial=false, int *errptr=0) const
String & | uriUnescapeStr (bool setPartial=false, int *errptr=0)
String | uriUnescape (int *errptr=0, bool setPartial=true) const
Public Member Functions inherited from GenObject
| GenObject ()
virtual | ~GenObject ()
virtual bool | alive () const
virtual const String & | traceId () const
NamedCounter * | getObjCounter () const
NamedCounter * | setObjCounter (NamedCounter *counter)

## Static Public Member Functions
static bool | build (const String &id, const char *file, const char *device=0, unsigned int repeat=0, bool resetExisting=true, bool stereo=false)
static bool | started (const String &name)
static bool | start (const String &name, bool force=true)
static void | stop (const String &name)
static ClientSound * | find (const String &token, bool byName=true)
Static Public Member Functions inherited from String
static const String & | empty ()
static const char * | boolText (bool value)
static int | lenUtf8 (const char *value, uint32_t maxChar=0x10ffff, bool overlong=false)
static bool | checkBOM (const char *str)
static bool | stripBOM (const char *&str)
static bool | stripBOM (char *&str)
static unsigned int | hash (const char *value, unsigned int h=0)
static String | msgEscape (const char *str, char extraEsc=0)
static String | msgUnescape (const char *str, int *errptr=0, char extraEsc=0)
static String | sqlEscape (const char *str, char extraEsc=0)
static String & | uriEscapeTo (String &buf, const char *str, char extraEsc=0, const char *noEsc=0)
static String & | uriEscapeTo (String &buf, const char *str, const char *extraEsc, const char *noEsc=0)
static String | uriEscape (const char *str, char extraEsc=0, const char *noEsc=0)
static String | uriEscape (const char *str, const char *extraEsc, const char *noEsc=0)
static String & | uriUnescapeTo (String &buf, const char *str, bool setPartial=false, int *errptr=0)
static String | uriUnescape (const char *str, int *errptr=0, bool setPartial=true)
static const String * | atom (const String *&str, const char *val)
static unsigned int | c_starts_with (const char *str, const char *what, int lenStr=-1, int lenWhat=-1, bool caseInsensitive=false)
static unsigned int | c_ends_with (const char *str, const char *what, int lenStr=-1, int lenWhat=-1, bool caseInsensitive=false)
static unsigned int | c_skip (const char *&str, const char *what, int lenStr=-1, int lenWhat=-1, bool caseInsensitive=false)
static unsigned int | c_skip_chars (const char *&str, const char *what, int len=-1, bool skipFound=true)
static char * | c_replace_chars (const char *str, const char *what, const char *repl=0, bool inPlace=false, int wLen=-1, int rLen=-1, bool *chg=0)
Static Public Member Functions inherited from GenObject
static void * | getObject (const String &name, const GenObject *obj)
static bool | getObjCounting ()
static void | setObjCounting (bool enable)
static NamedCounter * | getObjCounter (const String &name, bool create=true)
static ObjList & | getObjCounters ()

## Static Public Attributes
static ObjList | s_sounds
static Mutex | s_soundsMutex
static String | s_calltoPrefix

## Protected Member Functions
virtual bool | doStart ()
virtual void | doStop ()
Protected Member Functions inherited from String
virtual void | changed ()

## Protected Attributes
bool | m_native
String | m_file
String | m_device
unsigned int | m_repeat
bool | m_started
bool | m_stereo
String | m_channel

## Additional Inherited Members
Public Types inherited from String
enum | Align { Left = 0 , Center , Right }

## Detailed Description

A sound file.

This class holds a sound file along with an output device used to play it

## Constructor & Destructor Documentation

## ◆ ClientSound()

ClientSound | ( | const char * | name,
|  | const char * | file,
|  | const char * | device = 0 )
| inline

Constructor

Parameters

  name | The name of this object
  file | The file to play (should contain the whole path and the file name)
  device | Optional device used to play the file. Set to 0 to use the default one

## ◆ ~ClientSound()

virtual ~ClientSound | ( |  | ) |
| inlinevirtual

Destructor. Stop playing the file

References ClientSound::stop().

## Member Function Documentation

## ◆ attachSource()

bool attachSource | ( | ClientChannel * | chan | ) |

Attach this sound to a channel

Parameters

  chan | The channel to attach to

Returns
  True on success

## ◆ build()

static bool build | ( | const String & | id,
|  | const char * | file,
|  | const char * | device = 0,
|  | unsigned int | repeat = 0,
|  | bool | resetExisting = true,
|  | bool | stereo = false )
| static

Build a client sound

Parameters

  id | The name of the object
  file | The file to play (should contain the whole path and the file name)
  device | Optional device used to play the file. Set to 0 to use the default one
  repeat | The number of times to play the sound, 0 to repeat until explicitely stopped
  resetExisting | True to reset the file of an already created sound
  stereo | True if the sound file contains 2 channel audio

Returns
  True on success, false if the sound already exists

## ◆ destruct()

virtual void destruct | ( |  | ) |
| inlinevirtual

Stop playing. Release memory

Reimplemented from GenObject.

References GenObject::destruct(), and ClientSound::stop().

## ◆ device() [1/2]

const String & device | ( |  | ) | const
| inline

Get the device used to play this sound

Returns
  The device used to play sound

## ◆ device() [2/2]

void device | ( | const char * | dev | ) |
| inline

Set the device used to play this sound

Parameters

  dev | The device used to play sound

References ClientSound::s_soundsMutex.

## ◆ file() [1/2]

const String & file | ( |  | ) | const
| inline

Get the file played by this sound

Returns
  The file played by this sound

## ◆ file() [2/2]

void file | ( | const char * | filename,
|  | bool | stereo )
| inline

Set the file played by this sound. The new file will not be used until the next time the sound is started

Parameters

  filename | The new file played by this sound
  stereo | True if the file contains 2 channel audio

References ClientSound::s_soundsMutex, and ClientSound::stereo().

## ◆ find()

static ClientSound * find | ( | const String & | token,
|  | bool | byName = true )
| static

Find a sound object

Parameters

  token | The token used to match the sound
  byName | True to match the sound's name, false to match its file

Returns
  ClientSound pointer or 0 if not found

## ◆ native()

bool native | ( |  | ) | const
| inline

Check if this sound is a system dependent one

Returns
  True if the sound is played using a system dependent method, false if played using a yate module (like wavefile)

## ◆ setChannel()

void setChannel | ( | const String & | chan,
|  | bool | ok )

Set/reset channel on sound start/stop

Parameters

  chan | The channel id
  ok | Operation: true to start, false to stop

## ◆ setRepeat()

void setRepeat | ( | unsigned int | count | ) |
| inline

Set the repeat counter.

Parameters

  count | The number of times to play the sound, 0 to repeat until explicitely stopped

## ◆ start() [1/2]

bool start | ( | bool | force = true | ) |

Start playing the file

Parameters

  force | True to start playing the file even if already started

Returns
  True on success

## ◆ start() [2/2]

static bool start | ( | const String & | name,
|  | bool | force = true )
| static

Start playing a given sound

Parameters

  name | The name of the sound to play
  force | True to start playing the file even if already started

Returns
  True on success

## ◆ started() [1/2]

bool started | ( |  | ) | const
| inline

Check if this sound is started

Returns
  True if this sound is started

## ◆ started() [2/2]

static bool started | ( | const String & | name | ) |
| static

Check if a sound is started

Parameters

  name | The name of the sound to check

Returns
  True if the given sound is started

## ◆ stereo()

bool stereo | ( |  | ) | const
| inline

Check if this sound's file contains 2 channel audio

Returns
  True if the sound file contains 2 channel audio

Referenced by ClientSound::file().

## ◆ stop() [1/2]

void stop | ( |  | ) |

Stop playing the file

Referenced by ClientSound::destruct(), and ClientSound::~ClientSound().

## ◆ stop() [2/2]

static void stop | ( | const String & | name | ) |
| static

Stop playing a given sound

Parameters

  name | The name of the sound to stop

## Member Data Documentation

## ◆ s_calltoPrefix

String s_calltoPrefix
| static

The prefix to be added to the file when an utility channel is started or a sound is played in a regular client channel

## ◆ s_sounds

ObjList s_sounds
| static

The list of sounds

## ◆ s_soundsMutex

Mutex s_soundsMutex
| static

Mutex used to lock the sounds list operations

Referenced by ClientSound::device(), and ClientSound::file().

The documentation for this class was generated from the following file:

- yatecbase.h